// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

using JetBrains.Annotations;
using Microsoft.Data.Entity.Infrastructure;
using Microsoft.Data.Entity.Relational.Metadata;
using Microsoft.Data.Entity.Utilities;

namespace Microsoft.Data.Entity.Relational.Update
{
    public abstract class ModificationCommandBatchFactory : IModificationCommandBatchFactory
    {
        protected ModificationCommandBatchFactory(
            [NotNull] ISqlGenerator sqlGenerator)
        {
            Check.NotNull(sqlGenerator, nameof(sqlGenerator));

            SqlGenerator = sqlGenerator;
        }

        protected ISqlGenerator SqlGenerator { get; }

        public abstract ModificationCommandBatch Create(
            IEntityOptions options,
            IRelationalMetadataExtensionProvider metadataExtensionProvider);

        public virtual bool AddCommand(
            ModificationCommandBatch modificationCommandBatch,
            ModificationCommand modificationCommand)
            => Check.NotNull(modificationCommandBatch, nameof(modificationCommandBatch))
                .AddCommand(Check.NotNull(modificationCommand, nameof(modificationCommand)));
    }
}
